// read in a csv file on initialization of object
// automatically set num of outlets based on num of columns in csv
// send value of each column out of the respective outlet index on a bang
// outlet values are all strings

var csv_filename = ""

if (jsarguments.length > 1 ) {
	csv_filename = jsarguments[1]
}

var f = new File(csv_filename)
var data = f.readline()
var numColumns = data.split(",").length + 1
outlets = numColumns



function bang() {
	if (!f.isopen) {
		error("could not open file: " + csv_filename)
		return
	}
	
	if (f.position >= f.eof) {
		// reached end of file, looping back to start of file
		// set file pos to 0, then read in header line
		f.position = 0
		f.readline()
	}
	
	data = f.readline()
	var parseData = data.split(",")
	parseData.forEach( function(columnValue, i) {
		outlet(i, columnValue.trim())
		}
	)
}


function reset() {
	f.position = 0
	f.readline()
}


function findbounds(col) {
	// hopefully the data won't extend beyond these :-)
	var low = 999999
	var high = -999999
	
	if (!f.isopen) {
		error("could not open file: " + csv_filename)
		return
	}
	
	reset()
	
	while (f.position < f.eof) {
		data = f.readline()
		var parseData = data.split(",")
		parseData.forEach( function(columnValue, i) {
			if (i == col) {
				var val = Number(columnValue.trim(), 10)
				if (val != NaN) { // need to fix this for just empty cells (that return "0")
					if (val < low) low = val
					if (val > high) high = val
				}
			}
		}
		)
	}
	post("low:  " + low + "\n")
	post("high: " + high + "\n")
}


function listout() {
	var arr = []
	
	if (!f.isopen) {
		error("could not open file: " + csv_filename)
		return
	}
	
	if (f.position >= f.eof) {
		// reached end of file, looping back to start of file
		// set file pos to 0, then read in header line
		f.position = 0
		f.readline()
	}
	
	data = f.readline()
	var parseData = data.split(",")
	parseData.forEach( function(columnValue, i) {
		arr[i] = Number(columnValue.trim(), 10)
		}
	)
	
	outstr = arr.join(", ");
	outlet(0, outstr)
}
